﻿<UserControl x:Class="NotesApp.MVVM.Views.NotesView"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
             xmlns:local="clr-namespace:NotesApp.MVVM.Views"
             xmlns:vm="clr-namespace:NotesApp.MVVM.ViewModels"
             mc:Ignorable="d" d:DesignHeight="1080" d:DesignWidth="1920">
    
    <UserControl.DataContext>
        <vm:NotesViewModel/>
    </UserControl.DataContext>
    
    <Grid>
        <Grid.RowDefinitions>
            <RowDefinition Height="Auto"/>
            <RowDefinition/>
        </Grid.RowDefinitions>
        
        <Button HorizontalAlignment="Right" FontSize="24"
                Style="{StaticResource MainButton}" Foreground="{StaticResource PrimaryTextColor}"
                Command="{Binding AddNewNoteCommand}">
            <StackPanel Orientation="Horizontal">
                <TextBlock Text="New Note" Margin="0 0 10 0"/>
                <Image Source="{StaticResource AddNoteDrawingImage}"/>
            </StackPanel>
        </Button>
        
        <ListView ItemsSource="{Binding Notes}"
                  Background="Transparent" Grid.Row="1" Margin="0 10 0 0" BorderThickness="0"
                  ScrollViewer.HorizontalScrollBarVisibility="Hidden" ScrollViewer.VerticalScrollBarVisibility="Auto"
                  HorizontalContentAlignment="Stretch">
            
            <ListView.ItemContainerStyle>
                <Style TargetType="ListViewItem">
                    <Setter Property="Focusable" Value="False"/>
                </Style>
            </ListView.ItemContainerStyle>
            
            <ListView.ItemTemplate>
                <DataTemplate>
                    <Button Style="{StaticResource NoteListItemButton}"
                            CommandParameter="{Binding}" 
                            Command="{Binding DataContext.OpenNoteCommand, 
                                                RelativeSource={RelativeSource FindAncestor,
                                                    AncestorType={x:Type UserControl}}}">
                        
                        <Border BorderThickness="0 0 0 1" Padding="5" Margin="0 0 0 5" 
                                BorderBrush="{StaticResource SecondaryColor}" Background="Transparent">
                            <Grid>
                                <Grid.ColumnDefinitions>
                                    <ColumnDefinition Width="Auto"/>
                                    <ColumnDefinition/>
                                    <ColumnDefinition Width="Auto"/>
                                    <ColumnDefinition Width="Auto"/>
                                </Grid.ColumnDefinitions>
                                
                                <TextBlock Text="{Binding Title}" FontWeight="Bold"
                                           Foreground="{StaticResource PrimaryTextColor}" FontSize="16" 
                                           VerticalAlignment="Center"/>
                                
                                <StackPanel Grid.Column="2" Orientation="Horizontal" Tag="{Binding AlarmAt}">
                                    <Image Source="{StaticResource TimeDrawingImage}"/>
                                    <TextBlock Text="{Binding AlarmAt, StringFormat=g}" VerticalAlignment="Center"
                                               Foreground="{StaticResource SecondaryTextColor}"/>
                                    
                                    <StackPanel.Resources>
                                        <Style TargetType="{x:Type StackPanel}">
                                            <Style.Triggers>
                                                <Trigger Property="Tag" Value="{x:Null}">
                                                    <Setter Property="Visibility" Value="Collapsed"/>
                                                </Trigger>
                                            </Style.Triggers>
                                        </Style>
                                    </StackPanel.Resources>
                                </StackPanel>
                                
                                <StackPanel Grid.Column="3" Orientation="Horizontal" Margin="10 0 0 0">
                                    <Button Style="{StaticResource MainButton}"
                                            CommandParameter="{Binding}"
                                            Command="{Binding DataContext.DeleteNoteCommand, 
                                                RelativeSource={RelativeSource FindAncestor,
                                                    AncestorType={x:Type UserControl}}}">
                                        <Image Source="{StaticResource TrashDrawingImage}"/>
                                    </Button>
                                </StackPanel>
                                
                            </Grid>
                        </Border>
                    </Button>
                </DataTemplate>
            </ListView.ItemTemplate>
        </ListView>
        
    </Grid>
</UserControl>
